Policy Compliance
Get Policy Compliance For Job GA
GET
Returns the policy compliance status of a job. Jobs could be out of compliance if a cluster policy they use was updated after the job was last edited and some of its job clusters no longer comply with their updated policies.
API scopes: jobs
Parameters
- job_idint64query
The ID of the job whose compliance status you are requesting.
Response
- is_compliantboolean
Whether the job is compliant with its policies or not. Jobs could be out of compliance if a policy they are using was updated after the job was last edited and some of its job clusters no longer comply with their updated policies.
- violationsobject
An object containing key-value mappings representing the first 200 policy validation errors. The keys indicate the path where the policy validation error is occurring. An identifier for the job cluster is prepended to the path. The values indicate an error message describing the policy validation error.
List Job Compliance For Policy GA
GET
Returns the policy compliance status of all jobs that use a given policy. Jobs could be out of compliance if a cluster policy they use was updated after the job was last edited and its job clusters no longer comply with the updated policy.
API scopes: jobs
Parameters
- policy_idstringquery
Canonical unique identifier for the cluster policy.
- page_tokenstringquery
A page token that can be used to navigate to the next page or previous page as returned by
next_page_tokenorprev_page_token.
- page_sizeint32query
Use this field to specify the maximum number of results to be returned by the server. The server may further constrain the maximum number of results returned in a single page.
Response
- jobsarray of object
A list of jobs and their policy compliance statuses.
Show child attributesHide child attributes
- job_idint64
Canonical unique identifier for a job.
- is_compliantboolean
Whether this job is in compliance with the latest version of its policy.
- violationsobject
An object containing key-value mappings representing the first 200 policy validation errors. The keys indicate the path where the policy validation error is occurring. An identifier for the job cluster is prepended to the path. The values indicate an error message describing the policy validation error.
- next_page_tokenstring
This field represents the pagination token to retrieve the next page of results. If this field is not in the response, it means no further results for the request.
- prev_page_tokenstring
This field represents the pagination token to retrieve the previous page of results. If this field is not in the response, it means no further results for the request.
Enforce Policy Compliance For Job GA
POST
Updates a job so the job clusters that are created when running
the job (specified in new_cluster) are compliant with the
current versions of their respective cluster policies.
All-purpose clusters used in the job will not be updated.
API scopes: jobs
Request body
- job_idint64
The ID of the job you want to enforce policy compliance on.
- validate_onlyboolean
If set, previews changes made to the job to comply with its policy, but does not update the job.
Response
- has_changesboolean
Whether any changes have been made to the job cluster settings for the job to become compliant with its policies.
- job_cluster_changesarray of object
A list of job cluster changes that have been made to the job’s cluster settings in order for all job clusters to become compliant with their policies.
Show child attributesHide child attributes
- fieldstring
The field where this change would be made, prepended with the job cluster key.
- previous_valuestring
The previous value of this field before enforcing policy compliance (either a number, a boolean, or a string) converted to a string. This is intended to be read by a human. The type of the field can be retrieved by reading the settings field in the API response.
- new_valuestring
The new value of this field after enforcing policy compliance (either a number, a boolean, or a string) converted to a string. This is intended to be read by a human. The typed new value of this field can be retrieved by reading the settings field in the API response.
- settingsobject
Updated job settings after policy enforcement. Policy enforcement only applies to job clusters that are created when running the job (which are specified in new_cluster) and does not apply to existing all-purpose clusters. Updated job settings are derived by applying policy default values to the existing job clusters in order to satisfy policy requirements.
Show child attributesHide child attributes
- namestring
An optional name for the job. The maximum length is 4096 bytes in UTF-8 encoding.
- descriptionstring
An optional description for the job. The maximum length is 27700 characters in UTF-8 encoding.
- email_notificationsobject
An optional set of email addresses that is notified when runs of this job begin or complete as well as when this job is deleted.
Show child attributesHide child attributes
- on_startarray of string
A list of email addresses to be notified when a run begins. If not specified on job creation, reset, or update, the list is empty, and notifications are not sent.
- on_successarray of string
A list of email addresses to be notified when a run successfully completes. A run is considered to have completed successfully if it ends with a
TERMINATEDlife_cycle_stateand aSUCCESSresult_state. If not specified on job creation, reset, or update, the list is empty, and notifications are not sent.
- on_failurearray of string
A list of email addresses to be notified when a run unsuccessfully completes. A run is considered to have completed unsuccessfully if it ends with an
INTERNAL_ERRORlife_cycle_stateor aFAILED, orTIMED_OUTresult_state. If this is not specified on job creation, reset, or update the list is empty, and notifications are not sent.
- on_duration_warning_threshold_exceededarray of string
A list of email addresses to be notified when the duration of a run exceeds the threshold specified for the
RUN_DURATION_SECONDSmetric in thehealthfield. If no rule for theRUN_DURATION_SECONDSmetric is specified in thehealthfield for the job, notifications are not sent.
- on_streaming_backlog_exceededarray of stringPublic Preview
A list of email addresses to notify when any streaming backlog thresholds are exceeded for any stream. Streaming backlog thresholds can be set in the
healthfield using the following metrics:STREAMING_BACKLOG_BYTES,STREAMING_BACKLOG_RECORDS,STREAMING_BACKLOG_SECONDS, orSTREAMING_BACKLOG_FILES. Alerting is based on the 10-minute average of these metrics. If the issue persists, notifications are resent every 30 minutes.
- no_alert_for_skipped_runsboolean
If true, do not send email to recipients specified in
on_failureif the run is skipped. This field isdeprecated. Please use thenotification_settings.no_alert_for_skipped_runsfield.
- webhook_notificationsobject
A collection of system notification IDs to notify when runs of this job begin or complete.
Show child attributesHide child attributes
- on_startarray of object
An optional list of system notification IDs to call when the run starts. A maximum of 3 destinations can be specified for the
on_startproperty.Show child attributesHide child attributes
- idstring
- on_successarray of object
An optional list of system notification IDs to call when the run completes successfully. A maximum of 3 destinations can be specified for the
on_successproperty.Show child attributesHide child attributes
- idstring
- on_failurearray of object
An optional list of system notification IDs to call when the run fails. A maximum of 3 destinations can be specified for the
on_failureproperty.Show child attributesHide child attributes
- idstring
- on_duration_warning_threshold_exceededarray of object
An optional list of system notification IDs to call when the duration of a run exceeds the threshold specified for the
RUN_DURATION_SECONDSmetric in thehealthfield. A maximum of 3 destinations can be specified for theon_duration_warning_threshold_exceededproperty.Show child attributesHide child attributes
- idstring
- on_streaming_backlog_exceededarray of objectPublic Preview
An optional list of system notification IDs to call when any streaming backlog thresholds are exceeded for any stream. Streaming backlog thresholds can be set in the
healthfield using the following metrics:STREAMING_BACKLOG_BYTES,STREAMING_BACKLOG_RECORDS,STREAMING_BACKLOG_SECONDS, orSTREAMING_BACKLOG_FILES. Alerting is based on the 10-minute average of these metrics. If the issue persists, notifications are resent every 30 minutes. A maximum of 3 destinations can be specified for theon_streaming_backlog_exceededproperty.Show child attributesHide child attributes
- idstring
- notification_settingsobject
Optional notification settings that are used when sending notifications to each of the
email_notificationsandwebhook_notificationsfor this job.Show child attributesHide child attributes
- no_alert_for_skipped_runsboolean
If true, do not send notifications to recipients specified in
on_failureif the run is skipped.
- no_alert_for_canceled_runsboolean
If true, do not send notifications to recipients specified in
on_failureif the run is canceled.
- alert_on_last_attemptboolean
If true, do not send notifications to recipients specified in
on_startfor the retried runs and do not send notifications to recipients specified inon_failureuntil the last retry of the run.
- timeout_secondsint32
An optional timeout applied to each run of this job. A value of
0means no timeout.
- healthobject
Show child attributesHide child attributes
- rulesarray of object
Show child attributesHide child attributes
- metricstring
- opstring
- valueint64
Specifies the threshold value that the health metric should obey to satisfy the health rule.
- scheduleobject
An optional periodic schedule for this job. The default behavior is that the job only runs when triggered by clicking “Run Now” in the Jobs UI or sending an API request to
runNow.Show child attributesHide child attributes
- quartz_cron_expressionstring
A Cron expression using Quartz syntax that describes the schedule for a job. See Cron Trigger for details. This field is required.
- timezone_idstring
A Java timezone ID. The schedule for a job is resolved with respect to this timezone. See Java TimeZone for details. This field is required.
- pause_statusstring
Indicate whether this schedule is paused or not.
- triggerobject
A configuration to trigger a run when certain conditions are met. The default behavior is that the job runs only when triggered by clicking “Run Now” in the Jobs UI or sending an API request to
runNow.Show child attributesHide child attributes
- pause_statusstring
Whether this trigger is paused or not.
- file_arrivalobjectRequired
File arrival trigger settings.
Show child attributesHide child attributes
- urlstring
URL to be monitored for file arrivals. The path must point to the root or a subpath of the external location.
- min_time_between_triggers_secondsint32
If set, the trigger starts a run only after the specified amount of time passed since the last time the trigger fired. The minimum allowed value is 60 seconds
- wait_after_last_change_secondsint32
If set, the trigger starts a run only after no file activity has occurred for the specified amount of time. This makes it possible to wait for a batch of incoming files to arrive before triggering a run. The minimum allowed value is 60 seconds.
- periodicobjectRequired
Periodic trigger settings.
Show child attributesHide child attributes
- intervalint32
The interval at which the trigger should run.
- unitstring
The unit of time for the interval.
- table_updateobjectRequired
Show child attributesHide child attributes
- table_namesarray of string
A list of tables to monitor for changes. The table name must be in the format
catalog_name.schema_name.table_name.
- min_time_between_triggers_secondsint32
If set, the trigger starts a run only after the specified amount of time has passed since the last time the trigger fired. The minimum allowed value is 60 seconds.
- wait_after_last_change_secondsint32
If set, the trigger starts a run only after no table updates have occurred for the specified time and can be used to wait for a series of table updates before triggering a run. The minimum allowed value is 60 seconds.
- conditionstring
The table(s) condition based on which to trigger a job run.
- continuousobject
An optional continuous property for this job. The continuous property will ensure that there is always one run executing. Only one of
scheduleandcontinuouscan be used.Pipelines started by a continuous job also run continuously, regardless of their own pipeline mode setting.
Show child attributesHide child attributes
- pause_statusstring
Indicate whether the continuous execution of the job is paused or not. Defaults to UNPAUSED.
- task_retry_modestring
Indicate whether the continuous job is applying task level retries or not. Defaults to NEVER.
- max_concurrent_runsint32
An optional maximum allowed number of concurrent runs of the job. Set this value if you want to be able to execute multiple runs of the same job concurrently. This is useful for example if you trigger your job on a frequent schedule and want to allow consecutive runs to overlap with each other, or if you want to trigger multiple runs which differ by their input parameters. This setting affects only new runs. For example, suppose the job’s concurrency is 4 and there are 4 concurrent active runs. Then setting the concurrency to 3 won’t kill any of the active runs. However, from then on, new runs are skipped unless there are fewer than 3 active runs. This value cannot exceed 1000. Setting this value to
0causes all new runs to be skipped.
- tasksarray of object
A list of task specifications to be executed by this job. It supports up to 1000 elements in write endpoints (
jobs/create,jobs/reset,jobs/update,jobs/submit). Read endpoints return only 100 tasks. If more than 100 tasks are available, you can paginate through them usingjobs/get. Use thenext_page_tokenfield at the object root to determine if more results are available.Show child attributesHide child attributes
- task_keystring
A unique name for the task. This field is used to refer to this task from other tasks. This field is required and must be unique within its parent job. On Update or Reset, this field is used to reference the tasks to be updated or reset.
- depends_onarray of object
An optional array of objects specifying the dependency graph of the task. All tasks specified in this field must complete before executing this task. The task will run only if the
run_ifcondition is true. The key istask_key, and the value is the name assigned to the dependent task.Show child attributesHide child attributes
- task_keystring
The name of the task this task depends on.
- outcomestring
Can only be specified on condition task dependencies. The outcome of the dependent task that must be met for this task to run.
- run_ifstring
An optional value specifying the condition determining whether the task is run once its dependencies have been completed.
ALL_SUCCESS: All dependencies have executed and succeededAT_LEAST_ONE_SUCCESS: At least one dependency has succeededNONE_FAILED: None of the dependencies have failed and at least one was executedALL_DONE: All dependencies have been completedAT_LEAST_ONE_FAILED: At least one dependency failedALL_FAILED: ALl dependencies have failed
- timeout_secondsint32
An optional timeout applied to each run of this job task. A value of
0means no timeout.
- healthobject
Show child attributesHide child attributes
- rulesarray of object
- email_notificationsobject
An optional set of email addresses that is notified when runs of this task begin or complete as well as when this task is deleted. The default behavior is to not send any emails.
Show child attributesHide child attributes
- on_startarray of string
A list of email addresses to be notified when a run begins. If not specified on job creation, reset, or update, the list is empty, and notifications are not sent.
- on_successarray of string
A list of email addresses to be notified when a run successfully completes. A run is considered to have completed successfully if it ends with a
TERMINATEDlife_cycle_stateand aSUCCESSresult_state. If not specified on job creation, reset, or update, the list is empty, and notifications are not sent.
- on_failurearray of string
A list of email addresses to be notified when a run unsuccessfully completes. A run is considered to have completed unsuccessfully if it ends with an
INTERNAL_ERRORlife_cycle_stateor aFAILED, orTIMED_OUTresult_state. If this is not specified on job creation, reset, or update the list is empty, and notifications are not sent.
- on_duration_warning_threshold_exceededarray of string
A list of email addresses to be notified when the duration of a run exceeds the threshold specified for the
RUN_DURATION_SECONDSmetric in thehealthfield. If no rule for theRUN_DURATION_SECONDSmetric is specified in thehealthfield for the job, notifications are not sent.
- on_streaming_backlog_exceededarray of stringPublic Preview
A list of email addresses to notify when any streaming backlog thresholds are exceeded for any stream. Streaming backlog thresholds can be set in the
healthfield using the following metrics:STREAMING_BACKLOG_BYTES,STREAMING_BACKLOG_RECORDS,STREAMING_BACKLOG_SECONDS, orSTREAMING_BACKLOG_FILES. Alerting is based on the 10-minute average of these metrics. If the issue persists, notifications are resent every 30 minutes.
- no_alert_for_skipped_runsboolean
If true, do not send email to recipients specified in
on_failureif the run is skipped. This field isdeprecated. Please use thenotification_settings.no_alert_for_skipped_runsfield.
- notification_settingsobject
Optional notification settings that are used when sending notifications to each of the
email_notificationsandwebhook_notificationsfor this task.Show child attributesHide child attributes
- no_alert_for_skipped_runsboolean
If true, do not send notifications to recipients specified in
on_failureif the run is skipped.
- no_alert_for_canceled_runsboolean
If true, do not send notifications to recipients specified in
on_failureif the run is canceled.
- alert_on_last_attemptboolean
If true, do not send notifications to recipients specified in
on_startfor the retried runs and do not send notifications to recipients specified inon_failureuntil the last retry of the run.
- webhook_notificationsobject
A collection of system notification IDs to notify when runs of this task begin or complete. The default behavior is to not send any system notifications.
Show child attributesHide child attributes
- on_startarray of object
An optional list of system notification IDs to call when the run starts. A maximum of 3 destinations can be specified for the
on_startproperty.
- on_successarray of object
An optional list of system notification IDs to call when the run completes successfully. A maximum of 3 destinations can be specified for the
on_successproperty.
- on_failurearray of object
An optional list of system notification IDs to call when the run fails. A maximum of 3 destinations can be specified for the
on_failureproperty.
- on_duration_warning_threshold_exceededarray of object
An optional list of system notification IDs to call when the duration of a run exceeds the threshold specified for the
RUN_DURATION_SECONDSmetric in thehealthfield. A maximum of 3 destinations can be specified for theon_duration_warning_threshold_exceededproperty.
- on_streaming_backlog_exceededarray of objectPublic Preview
An optional list of system notification IDs to call when any streaming backlog thresholds are exceeded for any stream. Streaming backlog thresholds can be set in the
healthfield using the following metrics:STREAMING_BACKLOG_BYTES,STREAMING_BACKLOG_RECORDS,STREAMING_BACKLOG_SECONDS, orSTREAMING_BACKLOG_FILES. Alerting is based on the 10-minute average of these metrics. If the issue persists, notifications are resent every 30 minutes. A maximum of 3 destinations can be specified for theon_streaming_backlog_exceededproperty.
- descriptionstring
An optional description for this task.
- environment_keystringRequired
The key that references an environment spec in a job. This field is required for Python script, Python wheel and dbt tasks when using serverless compute.
- disabledboolean
An optional flag to disable the task. If set to true, the task will not run even if it is part of a job.
- computeobjectBeta
Task level compute configuration.
Show child attributesHide child attributes
- hardware_acceleratorstringBeta
Hardware accelerator configuration for Serverless GPU workloads.
- notebook_taskobjectRequired
The task runs a notebook when the
notebook_taskfield is present.Show child attributesHide child attributes
- notebook_pathstring
The path of the notebook to be run in the <Databricks> workspace or remote repository. For notebooks stored in the <Databricks> workspace, the path must be absolute and begin with a slash. For notebooks stored in a remote repository, the path must be relative. This field is required.
- base_parametersobject
Base parameters to be used for each run of this job. If the run is initiated by a call to
jobs/runNow with parameters specified, the two parameters maps are merged. If the same key is specified inbase_parametersand inrun-now, the value fromrun-nowis used. Use Task parameter variables to set parameters containing information about job runs.If the notebook takes a parameter that is not specified in the job’s
base_parametersor therun-nowoverride parameters, the default value from the notebook is used.Retrieve these parameters in a notebook using dbutils.widgets.get.
The JSON representation of this field cannot exceed 1MB.
- sourcestring
Optional location type of the notebook. When set to
WORKSPACE, the notebook will be retrieved from the local <Databricks> workspace. When set toGIT, the notebook will be retrieved from a Git repository defined ingit_source. If the value is empty, the task will useGITifgit_sourceis defined andWORKSPACEotherwise.WORKSPACE: Notebook is located in <Databricks> workspace.GIT: Notebook is located in cloud Git provider.
- warehouse_idstring
Optional
warehouse_idto run the notebook on a SQL warehouse. Classic SQL warehouses are NOT supported, please use serverless or pro SQL warehouses.Note that SQL warehouses only support SQL cells; if the notebook contains non-SQL cells, the run will fail.
- spark_jar_taskobjectRequired
The task runs a JAR when the
spark_jar_taskfield is present.Show child attributesHide child attributes
- jar_uristring
Deprecated since 04/2016. For classic compute, provide a
jarthrough thelibrariesfield instead. For serverless compute, provide ajarthough thejava_dependenciesfield inside theenvironmentslist.See the examples of classic and serverless compute usage at the top of the page.
- main_class_namestring
The full name of the class containing the main method to be executed. This class must be contained in a JAR provided as a library.
The code must use
SparkContext.getOrCreateto obtain a Spark context; otherwise, runs of the job fail.
- parametersarray of string
Parameters passed to the main method.
Use Task parameter variables to set parameters containing information about job runs.
- run_as_replboolean
Deprecated. A value of
falseis no longer supported.
- spark_python_taskobjectRequired
The task runs a Python file when the
spark_python_taskfield is present.Show child attributesHide child attributes
- python_filestring
The Python file to be executed. Cloud file URIs (such as dbfs:/, s3:/, adls:/, gcs:/) and workspace paths are supported. For python files stored in the <Databricks> workspace, the path must be absolute and begin with
/. For files stored in a remote repository, the path must be relative. This field is required.
- parametersarray of string
Command line parameters passed to the Python file.
Use Task parameter variables to set parameters containing information about job runs.
- sourcestring
Optional location type of the Python file. When set to
WORKSPACEor not specified, the file will be retrieved from the local <Databricks> workspace or cloud location (if thepython_filehas a URI format). When set toGIT, the Python file will be retrieved from a Git repository defined ingit_source.WORKSPACE: The Python file is located in a <Databricks> workspace or at a cloud filesystem URI.GIT: The Python file is located in a remote Git repository.
- spark_submit_taskobjectRequired
(Legacy) The task runs the spark-submit script when the spark_submit_task field is present. Databricks recommends using the spark_jar_task instead; see Spark Submit task for jobs.
Show child attributesHide child attributes
- parametersarray of string
Command-line parameters passed to spark submit.
Use Task parameter variables to set parameters containing information about job runs.
- pipeline_taskobjectRequired
The task triggers a pipeline update when the
pipeline_taskfield is present. Only pipelines configured to use triggered more are supported.Show child attributesHide child attributes
- pipeline_idstring
The full name of the pipeline task to execute.
- parametersobjectBeta
Key/value-map of parameters passed to the pipeline execution. Limited to 10k characters in total.
- full_refreshboolean
If true, triggers a full refresh on the spark declarative pipeline.
- refresh_selectionarray of stringBeta
A list of tables to update without fullRefresh.
- full_refresh_selectionarray of stringBeta
A list of tables to update with fullRefresh.
- reset_checkpoint_selectionarray of stringBeta
A list of streaming flows to reset checkpoints without clearing data.
- refresh_flow_selectionarray of stringBeta
Flow names to selectively refresh. These are unioned with other selective refresh options (refresh_selection, full_refresh_selection) to determine the final set of flows to refresh.
- python_wheel_taskobjectRequired
The task runs a Python wheel when the
python_wheel_taskfield is present.Show child attributesHide child attributes
- package_namestring
Name of the package to execute
- entry_pointstring
Named entry point to use, if it does not exist in the metadata of the package it executes the function from the package directly using
$packageName.$entryPoint()
- parametersarray of string
Command-line parameters passed to Python wheel task. Leave it empty if
named_parametersis not null.
- named_parametersobject
Command-line parameters passed to Python wheel task in the form of
["--name=task", "--data=dbfs:/path/to/data.json"]. Leave it empty ifparametersis not null.
- dbt_taskobjectRequired
The task runs one or more dbt commands when the
dbt_taskfield is present. The dbt task requires both Databricks SQL and the ability to use a serverless or a pro SQL warehouse.Show child attributesHide child attributes
- project_directorystring
Path to the project directory. Optional for Git sourced tasks, in which case if no value is provided, the root of the Git repository is used.
- commandsarray of string
A list of dbt commands to execute. All commands must start with
dbt. This parameter must not be empty. A maximum of up to 10 commands can be provided.
- schemastring
Optional schema to write to. This parameter is only used when a warehouse_id is also provided. If not provided, the
defaultschema is used.
- warehouse_idstring
ID of the SQL warehouse to connect to. If provided, we automatically generate and provide the profile and connection details to dbt. It can be overridden on a per-command basis by using the
--profiles-dircommand line argument.
- profiles_directorystring
Optional (relative) path to the profiles directory. Can only be specified if no warehouse_id is specified. If no warehouse_id is specified and this folder is unset, the root directory is used.
- catalogstring
Optional name of the catalog to use. The value is the top level in the 3-level namespace of Unity Catalog (catalog / schema / relation). The catalog value can only be specified if a warehouse_id is specified. Requires dbt-databricks >= 1.1.1.
- sourcestring
Optional location type of the project directory. When set to
WORKSPACE, the project will be retrieved from the local <Databricks> workspace. When set toGIT, the project will be retrieved from a Git repository defined ingit_source. If the value is empty, the task will useGITifgit_sourceis defined andWORKSPACEotherwise.WORKSPACE: Project is located in <Databricks> workspace.GIT: Project is located in cloud Git provider.
- sql_taskobjectRequired
The task runs a SQL query or file, or it refreshes a SQL alert or a legacy SQL dashboard when the
sql_taskfield is present.Show child attributesHide child attributes
- parametersobject
Parameters to be used for each run of this job. The SQL alert task does not support custom parameters.
- queryobjectRequired
If query, indicates that this job must execute a SQL query.
- dashboardobjectRequired
If dashboard, indicates that this job must refresh a SQL dashboard.
- alertobjectRequired
If alert, indicates that this job must refresh a SQL alert.
- fileobjectRequired
If file, indicates that this job runs a SQL file in a remote Git repository.
- warehouse_idstring
The canonical identifier of the SQL warehouse. Recommended to use with serverless or pro SQL warehouses. Classic SQL warehouses are only supported for SQL alert, dashboard and query tasks and are limited to scheduled single-task jobs.
- run_job_taskobjectRequired
The task triggers another job when the
run_job_taskfield is present.Show child attributesHide child attributes
- job_idint64
ID of the job to trigger.
- job_parametersobject
Job-level parameters used to trigger the job.
- pipeline_paramsobject
Controls whether the pipeline should perform a full refresh
- condition_taskobjectRequired
The task evaluates a condition that can be used to control the execution of other tasks when the
condition_taskfield is present. The condition task does not require a cluster to execute and does not support retries or notifications.Show child attributesHide child attributes
- opstring
EQUAL_TO,NOT_EQUALoperators perform string comparison of their operands. This means that“12.0” == “12”will evaluate tofalse.GREATER_THAN,GREATER_THAN_OR_EQUAL,LESS_THAN,LESS_THAN_OR_EQUALoperators perform numeric comparison of their operands.“12.0” >= “12”will evaluate totrue,“10.0” >= “12”will evaluate tofalse.
The boolean comparison to task values can be implemented with operators
EQUAL_TO,NOT_EQUAL. If a task value was set to a boolean value, it will be serialized to“true”or“false”for the comparison.
- leftstring
The left operand of the condition task. Can be either a string value or a job state or parameter reference.
- rightstring
The right operand of the condition task. Can be either a string value or a job state or parameter reference.
- outcomestring
The condition expression evaluation result. Filled in if the task was successfully completed. Can be
"true"or"false"
- for_each_taskobjectRequired
The task executes a nested task for every input provided when the
for_each_taskfield is present.Show child attributesHide child attributes
- inputsstring
Array for task to iterate on. This can be a JSON string or a reference to an array parameter.
- concurrencyint32
An optional maximum allowed number of concurrent runs of the task. Set this value if you want to be able to execute multiple runs of the task concurrently.
- taskobject
Configuration for the task that will be run for each element in the array
- clean_rooms_notebook_taskobjectRequired
The task runs a clean rooms notebook when the
clean_rooms_notebook_taskfield is present.Show child attributesHide child attributes
- clean_room_namestring
The clean room that the notebook belongs to.
- notebook_namestring
Name of the notebook being run.
- etagstring
Checksum to validate the freshness of the notebook resource (i.e. the notebook being run is the latest version). It can be fetched by calling the
cleanroomassets/getAPI.
- notebook_base_parametersobject
Base parameters to be used for the clean room notebook job.
- alert_taskobjectRequiredPublic Preview
The task evaluates a <Databricks> alert and sends notifications to subscribers when the
alert_taskfield is present.Show child attributesHide child attributes
- alert_idstringPublic Preview
The alert_id is the canonical identifier of the alert.
- warehouse_idstringPublic Preview
The warehouse_id identifies the warehouse settings used by the alert task.
- workspace_pathstringPublic Preview
The workspace_path is the path to the alert file in the workspace. The path:
- must start with "/Workspace"
- must be a normalized path. User has to select only one of alert_id or workspace_path to identify the alert.
- subscribersarray of objectPublic Preview
The subscribers receive alert evaluation result notifications after the alert task is completed. The number of subscriptions is limited to 100.
- power_bi_taskobjectRequiredPublic Preview
The task triggers a Power BI semantic model update when the
power_bi_taskfield is present.Show child attributesHide child attributes
- tablesarray of objectPublic Preview
The tables to be exported to Power BI
- warehouse_idstringPublic Preview
The SQL warehouse ID to use as the Power BI data source
- power_bi_modelobjectPublic Preview
The semantic model to update
- connection_resource_namestringPublic Preview
The resource name of the UC connection to authenticate from <Databricks> to Power BI
- refresh_after_updatebooleanPublic Preview
Whether the model should be refreshed after the update
- dashboard_taskobjectRequired
The task refreshes a dashboard and sends a snapshot to subscribers.
Show child attributesHide child attributes
- subscriptionobject
Optional: subscription configuration for sending the dashboard snapshot.
- warehouse_idstring
Optional: The warehouse id to execute the dashboard with for the schedule. If not specified, the default warehouse of the dashboard will be used.
- dashboard_idstring
The identifier of the dashboard to refresh.
- ai_runtime_taskobjectRequiredPublic Preview
The task runs a multi-gpu compute workload on Databricks AI Runtime. Specify the accelerator type and count, the command to run, and where the workload's code and MLflow output are stored.
Show child attributesHide child attributes
- experimentstringPublic Preview
MLflow experiment name for this run. If an experiment with this name already exists under the calling user, the run is appended to it; otherwise a new experiment is created. To target a specific MLflow storage location (for example, when running as a service principal), set
mlflow_experiment_directory.
- deploymentsarray of objectPublic Preview
Deployment specs for this task. Exactly one deployment is currently supported (a single entry where every node runs the same command); this is a current-Preview constraint. Role-split workloads (driver + worker, parameter server, separate eval node, etc.) with multiple entries are the eventual intent but not yet supported.
- mlflow_runstringPublic Preview
Optional display name for the MLflow run created under
experiment. If omitted, MLflow generates a default name.
- mlflow_experiment_directorystringPublic Preview
Optional workspace directory under which the MLflow experiment named in
experimentis created. Must start with/Workspace. Set this when running as a service principal that has no default user directory; for regular users the experiment defaults to the user's home directory.
- docker_image_urlstringBeta
Optional Docker image URL for a custom container image. When set, the task runs on the specified container image instead of the default <Databricks> client image. Format:
{organization}/{repository}:{tag}
- existing_cluster_idstringRequired
If existing_cluster_id, the ID of an existing cluster that is used for all runs. When running jobs or tasks on an existing cluster, you may need to manually restart the cluster if it stops responding. We suggest running jobs and tasks on new clusters for greater reliability
- new_clusterobjectRequired
If new_cluster, a description of a new cluster that is created for each run.
Show child attributesHide child attributes
- apply_policy_default_valuesboolean
- cluster_namestring
Cluster name requested by the user. This doesn't have to be unique. If not specified at creation, the cluster name will be an empty string. For job clusters, the cluster name is automatically set based on the job and job run IDs.
- spark_versionstring
The Spark version of the cluster, e.g.
3.3.x-scala2.11. A list of available Spark versions can be retrieved by using the clusters/sparkVersions API call.
- spark_confobject
An object containing a set of optional, user-specified Spark configuration key-value pairs. Users can also pass in a string of extra JVM options to the driver and the executors via
spark.driver.extraJavaOptionsandspark.executor.extraJavaOptionsrespectively.
- aws_attributesobject
Attributes related to clusters running on Amazon Web Services. If not specified at cluster creation, a set of default values will be used.
- azure_attributesobject
Attributes related to clusters running on Microsoft Azure. If not specified at cluster creation, a set of default values will be used.
- gcp_attributesobject
Attributes related to clusters running on Google Cloud Platform. If not specified at cluster creation, a set of default values will be used.
- node_type_idstring
This field encodes, through a single value, the resources available to each of the Spark nodes in this cluster. For example, the Spark nodes can be provisioned and optimized for memory or compute intensive workloads. A list of available node types can be retrieved by using the clusters/listNodeTypes API call.
- driver_node_type_idstring
The node type of the Spark driver. Note that this field is optional; if unset, the driver node type will be set as the same value as
node_type_iddefined above.This field, along with node_type_id, should not be set if virtual_cluster_size is set. If both driver_node_type_id, node_type_id, and virtual_cluster_size are specified, driver_node_type_id and node_type_id take precedence.
- worker_node_type_flexibilityobject
Flexible node type configuration for worker nodes.
- driver_node_type_flexibilityobject
Flexible node type configuration for the driver node.
- ssh_public_keysarray of string
SSH public key contents that will be added to each Spark node in this cluster. The corresponding private keys can be used to login with the user name
ubuntuon port2200. Up to 10 keys can be specified.
- custom_tagsobject
Additional tags for cluster resources. <Databricks> will tag all cluster resources (e.g., AWS instances and EBS volumes) with these tags in addition to
default_tags. Notes:-
Currently, <Databricks> allows at most 45 custom tags
-
Clusters can only reuse cloud resources if the resources' tags are a subset of the cluster tags
-
- cluster_log_confobject
The configuration for delivering spark logs to a long-term storage destination. Three kinds of destinations (DBFS, S3 and Unity Catalog volumes) are supported. Only one destination can be specified for one cluster. If the conf is given, the logs will be delivered to the destination every
5 mins. The destination of driver logs is$destination/$clusterId/driver, while the destination of executor logs is$destination/$clusterId/executor.
- spark_env_varsobject
An object containing a set of optional, user-specified environment variable key-value pairs. Please note that key-value pair of the form (X,Y) will be exported as is (i.e.,
export X='Y') while launching the driver and workers.In order to specify an additional set of
SPARK_DAEMON_JAVA_OPTS, we recommend appending them to$SPARK_DAEMON_JAVA_OPTSas shown in the example below. This ensures that all default databricks managed environmental variables are included as well.Example Spark environment variables:
{"SPARK_WORKER_MEMORY": "28000m", "SPARK_LOCAL_DIRS": "/local_disk0"}or{"SPARK_DAEMON_JAVA_OPTS": "$SPARK_DAEMON_JAVA_OPTS -Dspark.shuffle.service.enabled=true"}
- autotermination_minutesint32
Automatically terminates the cluster after it is inactive for this time in minutes. If not set, this cluster will not be automatically terminated. If specified, the threshold must be between 10 and 10000 minutes. Users can also set this value to 0 to explicitly disable automatic termination.
- enable_elastic_diskboolean
Autoscaling Local Storage: when enabled, this cluster will dynamically acquire additional disk space when its Spark workers are running low on disk space.
AWSAutoscaling Local Storage: when enabled, this cluster will dynamically acquire additional disk space when its Spark workers are running low on disk space. This feature requires specific AWS permissions to function correctly - refer to the User Guide for more details.
- init_scriptsarray of object
The configuration for storing init scripts. Any number of destinations can be specified. The scripts are executed sequentially in the order provided. If
cluster_log_confis specified, init script logs are sent to<destination>/<cluster-ID>/init_scripts.
- docker_imageobject
Custom docker image BYOC
- instance_pool_idstring
The optional ID of the instance pool to which the cluster belongs.
- single_user_namestring
Single user name if data_security_mode is
SINGLE_USER
- policy_idstring
The ID of the cluster policy used to create the cluster if applicable.
- enable_local_disk_encryptionboolean
Whether to enable LUKS on cluster VMs' local disks
- driver_instance_pool_idstring
The optional ID of the instance pool for the driver of the cluster belongs. The pool cluster uses the instance pool with id (instance_pool_id) if the driver pool is not assigned.
- workload_typeobject
- data_security_modestring
- runtime_enginestring
Determines the cluster's runtime engine, either standard or Photon.
This field is not compatible with legacy
spark_versionvalues that contain-photon-. Remove-photon-from thespark_versionand setruntime_enginetoPHOTON.If left unspecified, the runtime engine defaults to standard unless the spark_version contains -photon-, in which case Photon will be used.
- kindstring
- use_ml_runtimeboolean
This field can only be used when
kind = CLASSIC_PREVIEW.effective_spark_versionis determined byspark_version(DBR release), this fielduse_ml_runtime, and whethernode_type_idis gpu node or not.
- is_single_nodeboolean
This field can only be used when
kind = CLASSIC_PREVIEW.When set to true, <Databricks> will automatically set single node related
custom_tags,spark_conf, andnum_workers
- remote_disk_throughputint32
If set, what the configurable throughput (in Mb/s) for the remote disk is. Currently only supported for GCP HYPERDISK_BALANCED disks.
- total_initial_remote_disk_sizeint32
If set, what the total initial volume size (in GB) of the remote disks should be. Supported for GCP.
- dependency_modestringBeta
Controls dependency configuration for the cluster.
- num_workersint32Required
Number of worker nodes that this cluster should have. A cluster has one Spark Driver and
num_workersExecutors for a total ofnum_workers+ 1 Spark nodes.Note: When reading the properties of a cluster, this field reflects the desired number of workers rather than the actual current number of workers. For instance, if a cluster is resized from 5 to 10 workers, this field will immediately be updated to reflect the target size of 10 workers, whereas the workers listed in
spark_infowill gradually increase from 5 to 10 as the new nodes are provisioned.
- autoscaleobjectRequired
Parameters needed in order to automatically scale clusters up and down based on load. Note: autoscaling works best with DB runtime versions 3.0 or later.
- job_cluster_keystringRequired
If job_cluster_key, this task is executed reusing the cluster specified in
job.settings.job_clusters.
- librariesarray of object
An optional list of libraries to be installed on the cluster. The default value is an empty list.
Show child attributesHide child attributes
- jarstringRequired
URI of the JAR library to install. Supported URIs include Workspace paths, Unity Catalog Volumes paths, and S3 URIs. For example:
{ "jar": "/Workspace/path/to/library.jar" },{ "jar" : "/Volumes/path/to/library.jar" }or{ "jar": "s3://my-bucket/library.jar" }. If S3 is used, please make sure the cluster has read access on the library. You may need to launch the cluster with an IAM role to access the S3 URI.AzureURI of the JAR library to install. Supported URIs include Workspace paths, Unity Catalog Volumes paths, and ADLS URIs. For example:
{ "jar": "/Workspace/path/to/library.jar" },{ "jar" : "/Volumes/path/to/library.jar" }or{ "jar": "abfss://my-bucket/library.jar" }. If ADLS is used, please make sure the cluster has read access on the library. You may need to launch the cluster with a Microsoft Entra ID service principal to access the ADLS URI.GCPURI of the jar library to be installed. Supported URIs include Workspace path, UC Volumes path, and GCS URIs. For example:
{ "jar": "/Workspace/path/to/library.jar" },{ "jar" : "/Volumes/path/to/library.jar" }or{ "jar": "gs://my-bucket/library.jar" }. If GCS is used, please make sure the cluster has read access on the library. You may need to launch the cluster with an IAM service account to access the GCS URI.
- eggstringRequired
Deprecated. URI of the egg library to install. Installing Python egg files is deprecated and is not supported in Databricks Runtime 14.0 and above.
- pypiobjectRequired
Specification of a PyPi library to be installed. For example:
{ "package": "simplejson" }
- mavenobjectRequired
Specification of a maven library to be installed. For example:
{ "coordinates": "org.jsoup:jsoup:1.7.2" }
- cranobjectRequired
Specification of a CRAN library to be installed as part of the library
- whlstringRequired
URI of the wheel library to install. Supported URIs include Workspace paths, Unity Catalog Volumes paths, and S3 URIs. For example:
{ "whl": "/Workspace/path/to/library.whl" },{ "whl" : "/Volumes/path/to/library.whl" }or{ "whl": "s3://my-bucket/library.whl" }. If S3 is used, please make sure the cluster has read access on the library. You may need to launch the cluster with an IAM role to access the S3 URI.AzureURI of the wheel library to install. Supported URIs include Workspace paths, Unity Catalog Volumes paths, and ADLS URIs. For example:
{ "whl": "/Workspace/path/to/library.whl" },{ "whl" : "/Volumes/path/to/library.whl" }or{ "whl": "abfss://my-bucket/library.whl" }. If ADLS is used, please make sure the cluster has read access on the library. You may need to launch the cluster with a Microsoft Entra ID service principal to access the ADLS URI.GCPURI of the wheel library to be installed. Supported URIs include Workspace path, UC Volumes path, and GCS URIs. For example:
{ "whl": "/Workspace/path/to/library.whl" },{ "whl" : "/Volumes/path/to/library.whl" }or{ "whl": "gs://my-bucket/library.egg" }. If GCS is used, please make sure the cluster has read access on the library. You may need to launch the cluster with an IAM service account to access the GCS URI.
- requirementsstringRequired
URI of the requirements.txt file to install. Only Workspace paths and Unity Catalog Volumes paths are supported. For example:
{ "requirements": "/Workspace/path/to/requirements.txt" }or{ "requirements" : "/Volumes/path/to/requirements.txt" }
- max_retriesint32
An optional maximum number of times to retry an unsuccessful run. A run is considered to be unsuccessful if it completes with the
FAILEDresult_state orINTERNAL_ERRORlife_cycle_state. The value-1means to retry indefinitely and the value0means to never retry.
- min_retry_interval_millisint32
An optional minimal interval in milliseconds between the start of the failed run and the subsequent retry run. The default behavior is that unsuccessful runs are immediately retried.
- retry_on_timeoutboolean
An optional policy to specify whether to retry a job when it times out. The default behavior is to not retry on timeout.
- disable_auto_optimizationboolean
An option to disable auto optimization in serverless
- job_clustersarray of object
A list of job cluster specifications that can be shared and reused by tasks of this job. Libraries cannot be declared in a shared job cluster. You must declare dependent libraries in task settings.
Show child attributesHide child attributes
- job_cluster_keystring
A unique name for the job cluster. This field is required and must be unique within the job.
JobTaskSettingsmay refer to this field to determine which cluster to launch for the task execution.
- new_clusterobject
If new_cluster, a description of a cluster that is created for each task.
Show child attributesHide child attributes
- apply_policy_default_valuesboolean
- cluster_namestring
Cluster name requested by the user. This doesn't have to be unique. If not specified at creation, the cluster name will be an empty string. For job clusters, the cluster name is automatically set based on the job and job run IDs.
- spark_versionstring
The Spark version of the cluster, e.g.
3.3.x-scala2.11. A list of available Spark versions can be retrieved by using the clusters/sparkVersions API call.
- spark_confobject
An object containing a set of optional, user-specified Spark configuration key-value pairs. Users can also pass in a string of extra JVM options to the driver and the executors via
spark.driver.extraJavaOptionsandspark.executor.extraJavaOptionsrespectively.
- aws_attributesobject
Attributes related to clusters running on Amazon Web Services. If not specified at cluster creation, a set of default values will be used.
- azure_attributesobject
Attributes related to clusters running on Microsoft Azure. If not specified at cluster creation, a set of default values will be used.
- gcp_attributesobject
Attributes related to clusters running on Google Cloud Platform. If not specified at cluster creation, a set of default values will be used.
- node_type_idstring
This field encodes, through a single value, the resources available to each of the Spark nodes in this cluster. For example, the Spark nodes can be provisioned and optimized for memory or compute intensive workloads. A list of available node types can be retrieved by using the clusters/listNodeTypes API call.
- driver_node_type_idstring
The node type of the Spark driver. Note that this field is optional; if unset, the driver node type will be set as the same value as
node_type_iddefined above.This field, along with node_type_id, should not be set if virtual_cluster_size is set. If both driver_node_type_id, node_type_id, and virtual_cluster_size are specified, driver_node_type_id and node_type_id take precedence.
- worker_node_type_flexibilityobject
Flexible node type configuration for worker nodes.
- driver_node_type_flexibilityobject
Flexible node type configuration for the driver node.
- ssh_public_keysarray of string
SSH public key contents that will be added to each Spark node in this cluster. The corresponding private keys can be used to login with the user name
ubuntuon port2200. Up to 10 keys can be specified.
- custom_tagsobject
Additional tags for cluster resources. <Databricks> will tag all cluster resources (e.g., AWS instances and EBS volumes) with these tags in addition to
default_tags. Notes:-
Currently, <Databricks> allows at most 45 custom tags
-
Clusters can only reuse cloud resources if the resources' tags are a subset of the cluster tags
-
- cluster_log_confobject
The configuration for delivering spark logs to a long-term storage destination. Three kinds of destinations (DBFS, S3 and Unity Catalog volumes) are supported. Only one destination can be specified for one cluster. If the conf is given, the logs will be delivered to the destination every
5 mins. The destination of driver logs is$destination/$clusterId/driver, while the destination of executor logs is$destination/$clusterId/executor.
- spark_env_varsobject
An object containing a set of optional, user-specified environment variable key-value pairs. Please note that key-value pair of the form (X,Y) will be exported as is (i.e.,
export X='Y') while launching the driver and workers.In order to specify an additional set of
SPARK_DAEMON_JAVA_OPTS, we recommend appending them to$SPARK_DAEMON_JAVA_OPTSas shown in the example below. This ensures that all default databricks managed environmental variables are included as well.Example Spark environment variables:
{"SPARK_WORKER_MEMORY": "28000m", "SPARK_LOCAL_DIRS": "/local_disk0"}or{"SPARK_DAEMON_JAVA_OPTS": "$SPARK_DAEMON_JAVA_OPTS -Dspark.shuffle.service.enabled=true"}
- autotermination_minutesint32
Automatically terminates the cluster after it is inactive for this time in minutes. If not set, this cluster will not be automatically terminated. If specified, the threshold must be between 10 and 10000 minutes. Users can also set this value to 0 to explicitly disable automatic termination.
- enable_elastic_diskboolean
Autoscaling Local Storage: when enabled, this cluster will dynamically acquire additional disk space when its Spark workers are running low on disk space.
AWSAutoscaling Local Storage: when enabled, this cluster will dynamically acquire additional disk space when its Spark workers are running low on disk space. This feature requires specific AWS permissions to function correctly - refer to the User Guide for more details.
- init_scriptsarray of object
The configuration for storing init scripts. Any number of destinations can be specified. The scripts are executed sequentially in the order provided. If
cluster_log_confis specified, init script logs are sent to<destination>/<cluster-ID>/init_scripts.
- docker_imageobject
Custom docker image BYOC
- instance_pool_idstring
The optional ID of the instance pool to which the cluster belongs.
- single_user_namestring
Single user name if data_security_mode is
SINGLE_USER
- policy_idstring
The ID of the cluster policy used to create the cluster if applicable.
- enable_local_disk_encryptionboolean
Whether to enable LUKS on cluster VMs' local disks
- driver_instance_pool_idstring
The optional ID of the instance pool for the driver of the cluster belongs. The pool cluster uses the instance pool with id (instance_pool_id) if the driver pool is not assigned.
- workload_typeobject
- data_security_modestring
- runtime_enginestring
Determines the cluster's runtime engine, either standard or Photon.
This field is not compatible with legacy
spark_versionvalues that contain-photon-. Remove-photon-from thespark_versionand setruntime_enginetoPHOTON.If left unspecified, the runtime engine defaults to standard unless the spark_version contains -photon-, in which case Photon will be used.
- kindstring
- use_ml_runtimeboolean
This field can only be used when
kind = CLASSIC_PREVIEW.effective_spark_versionis determined byspark_version(DBR release), this fielduse_ml_runtime, and whethernode_type_idis gpu node or not.
- is_single_nodeboolean
This field can only be used when
kind = CLASSIC_PREVIEW.When set to true, <Databricks> will automatically set single node related
custom_tags,spark_conf, andnum_workers
- remote_disk_throughputint32
If set, what the configurable throughput (in Mb/s) for the remote disk is. Currently only supported for GCP HYPERDISK_BALANCED disks.
- total_initial_remote_disk_sizeint32
If set, what the total initial volume size (in GB) of the remote disks should be. Supported for GCP.
- dependency_modestringBeta
Controls dependency configuration for the cluster.
- num_workersint32Required
Number of worker nodes that this cluster should have. A cluster has one Spark Driver and
num_workersExecutors for a total ofnum_workers+ 1 Spark nodes.Note: When reading the properties of a cluster, this field reflects the desired number of workers rather than the actual current number of workers. For instance, if a cluster is resized from 5 to 10 workers, this field will immediately be updated to reflect the target size of 10 workers, whereas the workers listed in
spark_infowill gradually increase from 5 to 10 as the new nodes are provisioned.
- autoscaleobjectRequired
Parameters needed in order to automatically scale clusters up and down based on load. Note: autoscaling works best with DB runtime versions 3.0 or later.
- git_sourceobject
An optional specification for a remote Git repository containing the source code used by tasks. Version-controlled source code is supported by notebook, dbt, Python script, and SQL File tasks.
If
git_sourceis set, these tasks retrieve the file from the remote repository by default. However, this behavior can be overridden by settingsourcetoWORKSPACEon the task.Note: dbt and SQL File tasks support only version-controlled sources. If dbt or SQL File tasks are used,
git_sourcemust be defined on the job.Show child attributesHide child attributes
- git_urlstring
URL of the repository to be cloned by this job.
- git_providerstring
Unique identifier of the service used to host the Git repository. The value is case insensitive.
- git_branchstringRequired
Name of the branch to be checked out and used by this job. This field cannot be specified in conjunction with git_tag or git_commit.
- git_tagstringRequired
Name of the tag to be checked out and used by this job. This field cannot be specified in conjunction with git_branch or git_commit.
- git_commitstringRequired
Commit to be checked out and used by this job. This field cannot be specified in conjunction with git_branch or git_tag.
- git_snapshotobject
Show child attributesHide child attributes
- used_commitstring
Commit that was used to execute the run. If git_branch was specified, this points to the HEAD of the branch at the time of the run; if git_tag was specified, this points to the commit the tag points to.
- sparse_checkoutobject
Show child attributesHide child attributes
- patternsarray of string
List of patterns to include for sparse checkout.
- tagsobject
A map of tags associated with the job. These are forwarded to the cluster as cluster tags for jobs clusters, and are subject to the same limitations as cluster tags. A maximum of 25 tags can be added to the job.
- formatstring
Used to tell what is the format of the job. This field is ignored in Create/Update/Reset calls. When using the Jobs API 2.1 this value is always set to
"MULTI_TASK".
- queueobject
The queue settings of the job.
Show child attributesHide child attributes
- enabledboolean
If true, enable queueing for the job. This is a required field.
- parametersarray of object
Job-level parameter definitions
Show child attributesHide child attributes
- namestring
The name of the defined parameter. May only contain alphanumeric characters,
_,-, and.
- defaultstring
Default value of the parameter.
- run_asobject
The user or service principal that the job runs as, if specified in the request. This field indicates the explicit configuration of
run_asfor the job. To find the value in all cases, explicit or implicit, userun_as_user_name.Show child attributesHide child attributes
- user_namestringRequired
The email of an active workspace user. Non-admin users can only set this field to their own email.
- service_principal_namestringRequired
Application ID of an active service principal. Setting this field requires the
servicePrincipal/userrole.
- edit_modestring
Edit mode of the job.
UI_LOCKED: The job is in a locked UI state and cannot be modified.EDITABLE: The job is in an editable state and can be modified.
- deploymentobject
Deployment information for jobs managed by external sources.
Show child attributesHide child attributes
- kindstring
The kind of deployment that manages the job.
BUNDLE: The job is managed by Databricks Asset Bundle.SYSTEM_MANAGED: The job is managed by <Databricks> and is read-only.
- metadata_file_pathstring
Path of the file that contains deployment metadata.
- environmentsarray of object
A list of task execution environment specifications that can be referenced by serverless tasks of this job. For serverless notebook tasks, if the environment_key is not specified, the notebook environment will be used if present. If a jobs environment is specified, it will override the notebook environment. For other serverless tasks, the task environment is required to be specified using environment_key in the task settings.
Show child attributesHide child attributes
- environment_keystring
The key of an environment. It has to be unique within a job.
- specobject
Show child attributesHide child attributes
- clientstring
Use
environment_versioninstead.
- dependenciesarray of string
List of pip dependencies, as supported by the version of pip in this environment. Each dependency is a valid pip requirements file line per https://pip.pypa.io/en/stable/reference/requirements-file-format/. Allowed dependencies include a requirement specifier, an archive URL, a local project path (such as WSFS or UC Volumes in <Databricks>), or a VCS project URL.
- base_environmentstring
The base environment this environment is built on top of. A base environment defines the environment version and a list of dependencies for serverless compute. The value can be a file path to a custom
env.yamlfile (e.g.,/Workspace/path/to/env.yaml). Support for a <Databricks>-provided base environment ID (e.g.,workspace-base-environments/databricks_ai_v4) and workspace base environment ID (e.g.,workspace-base-environments/dbe_b849b66e-b31a-4cb5-b161-1f2b10877fb7) is in Beta. Eitherenvironment_versionorbase_environmentcan be provided. For more information about <Databricks>-provided base environments, see the list workspace base environments API. For more information, seeAWSThe base environment this environment is built on top of. A base environment defines the environment version and a list of dependencies for serverless compute. The value can be a file path to a custom
env.yamlfile (e.g.,/Workspace/path/to/env.yaml). Support for a <Databricks>-provided base environment ID (e.g.,workspace-base-environments/databricks_ai_v4) and workspace base environment ID (e.g.,workspace-base-environments/dbe_b849b66e-b31a-4cb5-b161-1f2b10877fb7) is in Beta. Eitherenvironment_versionorbase_environmentcan be provided. For more information about <Databricks>-provided base environments, see the list workspace base environments API. For more information, see https://docs.databricks.com/aws/en/compute/serverless/dependencies#base-environments-for-job-tasks.AzureThe base environment this environment is built on top of. A base environment defines the environment version and a list of dependencies for serverless compute. The value can be a file path to a custom
env.yamlfile (e.g.,/Workspace/path/to/env.yaml). Support for a <Databricks>-provided base environment ID (e.g.,workspace-base-environments/databricks_ai_v4) and workspace base environment ID (e.g.,workspace-base-environments/dbe_b849b66e-b31a-4cb5-b161-1f2b10877fb7) is in Beta. Eitherenvironment_versionorbase_environmentcan be provided. For more information about <Databricks>-provided base environments, see the list workspace base environments API. For more information, seeGCPThe base environment this environment is built on top of. A base environment defines the environment version and a list of dependencies for serverless compute. The value can be a file path to a custom
env.yamlfile (e.g.,/Workspace/path/to/env.yaml). Support for a <Databricks>-provided base environment ID (e.g.,workspace-base-environments/databricks_ai_v4) and workspace base environment ID (e.g.,workspace-base-environments/dbe_b849b66e-b31a-4cb5-b161-1f2b10877fb7) is in Beta. Eitherenvironment_versionorbase_environmentcan be provided. For more information about <Databricks>-provided base environments, see the list workspace base environments API. For more information, seehttps://docs.databricks.com/gcp/en/compute/serverless/dependencies#base-environments-for-job-tasks.
- environment_versionstring
Either
environment_versionorbase_environmentneeds to be provided. Environment version used by the environment. Each version comes with a specific Python version and a set of Python packages. The version is a string, consisting of an integer.AWSEither
environment_versionorbase_environmentneeds to be provided. Environment version used by the environment. Each version comes with a specific Python version and a set of Python packages. The version is a string, consisting of an integer. See https://docs.databricks.com/aws/release-notes/serverless/#serverless-environment-versions.AzureEither
environment_versionorbase_environmentneeds to be provided. Environment version used by the environment. Each version comes with a specific Python version and a set of Python packages. The version is a string, consisting of an integer.GCPEither
environment_versionorbase_environmentneeds to be provided. Environment version used by the environment. Each version comes with a specific Python version and a set of Python packages. The version is a string, consisting of an integer.See https://docs.databricks.com/gcp/release-notes/serverless/#serverless-environment-versions.
- java_dependenciesarray of string
List of java dependencies. Each dependency is a string representing a java library path. For example:
/Volumes/path/to/test.jar.AWSList of java dependencies. Each dependency is a string representing a java library path. For example:
/Volumes/path/to/test.jar. See https://docs.databricks.com/aws/en/jobs/jar.AzureList of java dependencies. Each dependency is a string representing a java library path. For example:
/Volumes/path/to/test.jar.See https://learn.microsoft.com/en-gb/azure/databricks/jobs/jar.
GCPList of java dependencies. Each dependency is a string representing a java library path. For example:
/Volumes/path/to/test.jar.
- budget_policy_idstringPublic Preview
The id of the user specified budget policy to use for this job. If not specified, a default budget policy may be applied when creating or modifying the job. See
effective_budget_policy_idfor the budget policy used by this workload.
- performance_targetstring
The performance mode on a serverless job. This field determines the level of compute performance or cost-efficiency for the run. The performance target does not apply to tasks that run on Serverless GPU compute.
STANDARD: Enables cost-efficient execution of serverless workloads.PERFORMANCE_OPTIMIZED: Prioritizes fast startup and execution times through rapid scaling and optimized cluster performance.
- triggersarray of objectBeta
List of triggers attached to this job. A run starts when any active trigger evaluates to true. Cannot be set in the same request as the legacy
schedule,trigger, orcontinuousfields. Gated behind the "Multiple Triggers" feature preview.Show child attributesHide child attributes
- pause_statusstringBeta
Whether this trigger is paused. Defaults to UNPAUSED when unset; the server always returns an explicit value on read.
- periodicobjectBeta
Trigger type: exactly one must be set; mutual exclusivity is enforced in the API handler Periodic trigger configuration.
Show child attributesHide child attributes
- intervalint32
The interval at which the trigger should run.
- unitstring
The unit of time for the interval.
- scheduleobjectBeta
Cron schedule trigger configuration.
Show child attributesHide child attributes
- quartz_cron_expressionstringBeta
A Cron expression using Quartz syntax that describes the schedule for this trigger. See Cron Trigger for details.
- timezone_idstringBeta
A Java timezone ID. The schedule is resolved with respect to this timezone. See Java TimeZone for details.
- continuousobjectBeta
Continuous trigger configuration.
Show child attributesHide child attributes
- task_retry_modestringBeta
Whether the continuous job applies task-level retries. Defaults to NEVER.
- file_arrivalobjectBeta
File arrival trigger configuration.
Show child attributesHide child attributes
- urlstring
URL to be monitored for file arrivals. The path must point to the root or a subpath of the external location.
- min_time_between_triggers_secondsint32
If set, the trigger starts a run only after the specified amount of time passed since the last time the trigger fired. The minimum allowed value is 60 seconds
- wait_after_last_change_secondsint32
If set, the trigger starts a run only after no file activity has occurred for the specified amount of time. This makes it possible to wait for a batch of incoming files to arrive before triggering a run. The minimum allowed value is 60 seconds.
- table_updateobjectBeta
Table update trigger configuration.
Show child attributesHide child attributes
- table_namesarray of string
A list of tables to monitor for changes. The table name must be in the format
catalog_name.schema_name.table_name.
- min_time_between_triggers_secondsint32
If set, the trigger starts a run only after the specified amount of time has passed since the last time the trigger fired. The minimum allowed value is 60 seconds.
- wait_after_last_change_secondsint32
If set, the trigger starts a run only after no table updates have occurred for the specified time and can be used to wait for a series of table updates before triggering a run. The minimum allowed value is 60 seconds.
- conditionstring
The table(s) condition based on which to trigger a job run.
- max_retriesint32
An optional maximum number of times to retry an unsuccessful run. A run is considered to be unsuccessful if it completes with the
FAILEDresult_state orINTERNAL_ERRORlife_cycle_state. The value-1means to retry indefinitely and the value0means to never retry.
- min_retry_interval_millisint32
An optional minimal interval in milliseconds between the start of the failed run and the subsequent retry run. The default behavior is that unsuccessful runs are immediately retried.
- retry_on_timeoutboolean
An optional policy to specify whether to retry a job when it times out. The default behavior is to not retry on timeout.
- disable_auto_optimizationboolean
An option to disable auto optimization in serverless